#include <stdio.h>
#include <stdlib.h>

main(int argc,char **argv)
{
	FILE	*fm;
	int		r;
	int		ad;
	int		sm,sc,sm2;
	int		i,j;
	int		oset;

	if (argc != 3) {
		printf("Usage:%c offset infile \n",argv[0]);
		exit(1);
	}

	sscanf(argv[1],"%X",&oset);

	if ((fm = fopen(argv[2],"rb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	j = oset / 8;
	sm2 = 0;

	for (;;) {
		fscanf(fm,"%X",&ad);
		if (ad == 0xFFFF) {
			break;
		}

		sm = (ad & 0xFF00) >> 8;
		sm += (ad & 0xFF);

		for (i = 0;i < 8;i ++) {
			fscanf(fm,"%X",&r);
			sm += r;
			sm2 += r;
		}

		fscanf(fm,"%X",&sc);
		if ( (sm & 0xFF) != (sc & 0xFF) ) {
			printf("%04X:",ad);
			printf(":%02X:",(sm & 0xFF));
			printf(":%02X:",(sc & 0xFF));
			printf("NG\n");
		}
		j ++;
		if (j == 32) {
			fscanf(fm,"%X",&sc);
			if ( (sm2 & 0xFF) != (sc & 0xff) ){
				printf("%04X:SUMALL ",ad);
				printf(":%02X:",(sm2 & 0xFF));
				printf(":%02X:",(sc & 0xFF));
				printf("NG\n");
			}
			j = 0;
			sm2 = 0;
		}
	}

	fclose(fm);
}
